<?php
class googleChartsApi_PMPro {
	var $yscale; 
	var $nodes=50;
	var $ymin;
	var $ymax;
	var $xmax;
	var $xLabelPartitions=4;
    var $simpleEncoding = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789' ;
	var $valuesAtNodes;
    
	function googleChartsApi_PMPro(&$xvalues, &$yvalues) {
		$tmp = max($yvalues) - min($yvalues);
		$t1 = 25; $t2 = 3.125;
		while ($t1<$tmp) {
			$t1 *= 2;
			$t2 *= 2;
		}
		$tmp = $t2;
		$this->yscale=$tmp; 		
		$this->valuesAtNodes=googleChartsApi_PMPro::getValuesAtNodes($xvalues,$yvalues) ;
		$this->ymin=floor(min($this->valuesAtNodes)/$this->yscale)*$this->yscale;
		$this->ymax=ceil(max($this->valuesAtNodes)/$this->yscale)*$this->yscale;
		$this->ypartitions=($this->ymax-$this->ymin)/$this->yscale;
		$this->xmax=ceil($xvalues[count($xvalues)-1]);		 
	}
	
	function simpleEncodeValues(&$values, $min, $max) {
		$chartData= "" ;
		$distance= $max-$min;
		for ($l = 0; $l < count($values); $l++) {
			$value=round(($values[$l]-$min)/$distance*61) ;
			$chartData = $chartData . $this->simpleEncoding[$value] ;
		}		
		return $chartData ;		
	}
	
	
	function getValuesAtNodes(&$xvalues,&$yvalues) {
		$xmax= $xvalues[count($xvalues)-1];
		$xstep= $xmax / ($this->nodes - 1 ) ;
		$nextNode= 0;
		$valuesAtNodes = array();
		$k=0;
		for ($j = 0; $j < count($xvalues); $j++) {
			if ($xvalues[$j]>=$nextNode) {
	    		$valuesAtNodes[$k++] = $yvalues[$j];
				$nextNode += $xstep;
			}
		}
		return $valuesAtNodes;
	}

	function getYLabels($measurementtype) {
		$ylabels=array() ;
		for ($yentry=$this->ymin;$yentry <= $this->ymax;$yentry+=$this->yscale) {
			if ($measurementtype == "imperial") {
				$ylabels[]=round($yentry,1)." ft";
			} else {
  				$ylabels[]=round($yentry,1)." m";
			}
  			
		}
		return $ylabels;
	}
	
	function getXLabels($measurementtype) {
		$xlabels=array();
		$xstep=$this->xmax/$this->xLabelPartitions;
		for ($xentry=0;$xentry <= $this->xLabelPartitions;$xentry++) {
			if ($measurementtype == "imperial") {
  				$xlabels[]=round($xentry * $xstep, 1)." mi";
			} else {
				$xlabels[]=round($xentry * $xstep, 1)." km";
			}
		}
		return $xlabels ;
	}
	
	function getUrl($width, $height, $linecolor, $linewidth, $measurementtype) {
		$chart = array() ;
		// Type
		$chart['cht']="lc" ;
		// line style
		$chart['chls']=$linewidth.",0,0";
		// fill with horizontal stripes (90 degree)
		$stripeHeight=1/$this->ypartitions;
		$chart['chf']="c,ls,90,CCCCCC,".$stripeHeight.",FFFFFF,".$stripeHeight;
		// Labels
		$chart['chxt']="x,y";
		$chart['chxl']="0:|".join("|",$this->getXLabels($measurementtype))."|1:|".join("|",$this->getYLabels($measurementtype)) ;
		// Data
		$chart['chd']="s:".$this->simpleEncodeValues($this->valuesAtNodes, $this->ymin, $this->ymax);
		// Size
		$chart['chs']=$width."x".$height;
		$chart['chco']=$linecolor;
		$params=array() ;
		foreach ($chart as $key => $value){
	    	$params[] = $key."=".$value;
  		}
		return "http://chart.apis.google.com/chart?".join("&",$params);
	}
	
}
?>