<?php
class gpxParser{
   var $xml_obj = null;
   var $output = array();
   var $attrs;
   var $rtept=0;
   var $trkpt=0;
   var $wpt=0;
   var $rte=-1;
   var $trkseg=-1;
   var $currentwpt=-1;
   var $currentdata=null;
   var $readingdata=0;
   var $key1="";
   var $key2="";
   
   function startHandler($parser, $name, $attribs){
   		switch ($name) {
   			case "RTE":
   				$this->rte++;
   				$this->rtept = 0;
   				break;
   			case "RTEPT":
   				$this->key1 = "rte".$this->rte;
   				$this->key2 = "rtept".$this->rtept;
   				$this->output[$this->key1][$this->key2] = $attribs;
   				$this->rtept++;
   				$this->output[$this->key1]["rtept_count"] = $this->rtept;
   				break;
   			case "TRKSEG":
   				$this->trkseg++;
   				$this->trkpt = 0;
   				break;
   			case "TRKPT":
   				$this->key1 = "trk".$this->trkseg;
   				$this->key2 = "trkpt".$this->trkpt;
   				$this->output[$this->key1][$this->key2] = $attribs;   				
   				$this->trkpt++;
   				$this->output[$this->key1]["trkpt_count"] = $this->trkpt;
   				break;
   			case "WPT":
   				$this->key1 = "wpt".$this->wpt;
				$this->output[$this->key1] = $attribs;
				$this->currentwpt = $this->wpt;
				$this->wpt++;
				break;			
			case "LINK":
				if (substr($this->key1,0,3)=="wpt") {
					$this->output[$this->key1]["LINK"]=$attribs["HREF"];
				}
				break;						
			case "BOUNDS":
				$this->output["bounds"] = $attribs;
				break;	
			default:
				if (strlen($this->key1)>0) {
					$this->currentdata=null;
					$this->readingdata=1;					
				}				
				break;
   		}
   		$this->lastelement = $name;
   }

   function dataHandler($parser, $data){
   	if ($this->readingdata) {
   		$this->currentdata=$data;
   		$this->readingdata=0;
   	}
   }

   function endHandler($parser, $name){
      switch ($name) {
      	case "WPT":
 			$this->key1 = "";
 			$this->key2 = "";
      		$this->currentwpt = -1;
      	   break;
		case "TRKPT":
		case "RTEPT":		
 			$this->key1 = "";
 			$this->key2 = "";
      		break;
      	default:
      		if ((strlen($this->key1)>0) && (strlen($this->key2)>0)) {
      			$this->output[$this->key1][$this->key2][$name] = $this->currentdata;
      			$this->currentdata=null;
      		} else {
	      		if ((strlen($this->key1)>0)) {
	      			$this->output[$this->key1][$name] = $this->currentdata;
	      			$this->currentdata=null;
	      		}
      		}
      	   break;
      }
   }

   function parse($path){
		$this->xml_obj = xml_parser_create();       
		xml_set_object($this->xml_obj,$this);
		xml_set_character_data_handler($this->xml_obj, 'dataHandler');
		xml_set_element_handler($this->xml_obj, "startHandler", "endHandler");
   	
   	   	$this->output = array();
  		$this->attrs = null;
   		$this->rtept=0;
   		$this->trkpt=0;
   		$this->currentwpt=-1;
   		$this->currentdata=null;
   		$this->readingdata=0;
   		$this->key1="";
   		$this->key2="";   	   
   	   $this->rte=-1;	
   	   $this->trkseg=-1;
   	   $this->wpt=0;
       if (!($fp = fopen($path, "r"))) {
           die("Cannot open XML data file: $path");
           return false;
       }
	   $filecontent = "";
       while ($data = fread($fp, 4096)) {
       		$filecontent .= $data;
       }
       
       if (!xml_parse($this->xml_obj, $filecontent, feof($fp))) {
           die(sprintf("XML error: %s at line %d",
           xml_error_string(xml_get_error_code($this->xml_obj)),
           xml_get_current_line_number($this->xml_obj)));
           xml_parser_free($this->xml_obj);
           return false;           
       }
       xml_parser_free($this->xml_obj);

       $this->output["wpt_count"] = $this->wpt;
       $this->output["rte_count"] = $this->rte+1;
       $this->output["trk_count"] = $this->trkseg+1;
       
       return true;
   }   
   
}

?>