<?php 

	class xml_gm_params {
		
		function xml_gm_params() {
			$this->width = intval(get_option(key_xmlgm_width));
			$this->height = intval(get_option(key_xmlgm_height));
			$this->align = intval(get_option(key_xmlgm_align));
			$this->googleMapsAPIKey = get_option(key_xmlgm_uid); 	
			$this->viewStyle = get_option(key_xmlgm_viewstyle);
			$this->urlDisplayMode = get_option(key_xmlgm_urldisplaymode);
			$this->panZoomControl = get_option(key_xmlgm_panzoomcontrol);
			$this->overViewMapControl = get_option(key_xmlgm_overviewmap);
			$this->scaleControl = get_option(key_xmlgm_scalecontrol);
			$this->mapTypeControl = get_option(key_xmlgm_maptypecontrol);
			
			$this->gpxLineColor = get_option(key_xmlgm_linecolor);
			$this->gpxLineWidth = intval(get_option(key_xmlgm_linewidth));
			$this->gpxLineOpacity = intval(get_option(key_xmlgm_lineopacity));
			$this->gpxView = get_option(key_xmlgm_gpxview);
			$this->gpxElevationLineColor = str_replace("#","",get_option(key_xmlgm_elevlinecolor));
			$this->gpxElevationChart = get_option(key_xmlgm_elevationchart);
			$this->gpxElevationLineWidth = intval(get_option(key_xmlgm_elelinewidth));
			$this->gpxElevationChartHeight = intval(get_option(key_xmlgm_elevationheight));
			$this->gpxElevationMeasurement = get_option(key_xmlgm_elevationmeasurement);
			$this->gpxCSSStyle = get_option(key_xmlgm_gpxcssstyle);
		}				
		
		var $width = 664;
		var $height = 400;
		var $align = "left";
		var $googleMapsAPIKey = "";
		var $viewStyle = "G_MAP_TYPE";
		var $urlDisplayMode = "title";
		var $panZoomControl = "large";
		var $overViewMapControl = "hide";	
		var $scaleControl = "hide";	
		var $mapTypeControl = "show";		
		
		var $manualZoom = 0;
		var $minLat = 0;
		var $maxLat = 0;
		var $minLon = 0;
		var $maxLon = 0;
		var $zoom = 0;
		var $deltazoom = 0;
				
		var $gpxLineColor = "#0000FF";
		var $gpxLineWidth = 5;
		var $gpxLineOpacity = 50;
		var $gpxView = "all";
		var $gpxInterval = 1;
		var $gpxElevationLineColor = "0000FF";
		var $gpxElevationLineWidth = 5;
		var $gpxElevationChart = "show";	
		var $gpxElevationChartHeight = 200;
		var $gpxElevationMeasurement = "metric";
		var $gpxCSSStyle = "font-family: Verdana, Arial, Sans-Serif;";	
			
		function setParams($param_string) {
			$manualzoom = 0;
			$vars = split(";",$param_string);	
			for ($i=0 ;$i<count($vars);$i++) {
				$varvalue=split("=",$vars[$i]);
				if (count($varvalue)==2) {
					switch (strtolower($varvalue[0])) {
						case "urldisplaymode":
							$this->urlDisplayMode = $varvalue[1];			
							break;							
						case "maptype":
							$this->viewStyle = $varvalue[1];			
							break;
						case "width":
							if (is_numeric($varvalue[1])) {
								$this->width = intval($varvalue[1]);								
							}
							break;							
						case "height":
							if (is_numeric($varvalue[1])) {
								$this->height = intval($varvalue[1]);								
							}
							break;
						case "align":
							$this->align = $varvalue[1];
							break;
						case "panzoomcontrol":
							$this->panZoomControl = $varvalue[1];
							break;
						case "overviewmapcontrol":
							$this->overViewMapControl = $varvalue[1];
							break;							
						case "scalecontrol":
							$this->scaleControl = $varvalue[1];
							break;							
						case "maptypecontrol":
							$this->mapTypeControl = $varvalue[1];
							break;							
						case "gpxinterval":
							if (is_numeric($varvalue[1])) {
								$this->gpxInterval = intval($varvalue[1]);								
							}
							break;
						case "gpxcolor":
							$this->gpxLineColor = $varvalue[1];
							break;
						case "gpxelevationcolor":
							$this->gpxElevationLineColor = str_replace("#","",$varvalue[1]);
							break;							
						case "gpxelevation":
							$this->gpxElevationChart = $varvalue[1];
							break;							
						case "gpxelevationmeasurement":
							$this->gpxElevationMeasurement = $varvalue[1];
							break;
						case "gpxlinewidth";
							if (is_numeric($varvalue[1])) {
								$this->gpxLineWidth = intval($varvalue[1]);								
							}
							break;
						case "gpxelevationlinewidth";
							if (is_numeric($varvalue[1])) {
								$this->gpxElevationLineWidth = intval($varvalue[1]);								
							}
							break;	
						case "gpxelevationheight";
							if (is_numeric($varvalue[1])) {
								$this->gpxElevationChartHeight = intval($varvalue[1]);								
							}
							break;														
						case "gpxlineopacity":					
							if (is_numeric($varvalue[1])) {
								$this->gpxLineOpacity = intval($varvalue[1]);								
							}
							break;
						case "gpxview":
							$this->gpxView = $varvalue[1];					
							break;
						case "maxlat":					
							if (is_numeric($varvalue[1])) {
								$this->maxLat = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;					
						case "maxlon":					
							if (is_numeric($varvalue[1])) {
								$this->maxLon = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;		
						case "minlat":					
							if (is_numeric($varvalue[1])) {
								$this->minLat = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;					
						case "minlon":					
							if (is_numeric($varvalue[1])) {
								$this->minLon = doubleval($varvalue[1]);
								$this->manualZoom++;								
							}
							break;	
						case "zoom":					
							if (is_numeric($varvalue[1])) {
								$this->zoom = intval($varvalue[1]);							
							}
							break;	
						case "deltazoom":					
							if (is_numeric($varvalue[1])) {
								$this->deltazoom = intval($varvalue[1]);							
							}
							break;	
					}
				}
			}			
		}		
	} 
	
?>