<?php
	require_once('../../../wp-config.php');
?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xmlns:v="urn:schemas-microsoft-com:vml">
  <head>
    <meta http-equiv="content-type" content="text/html; charset=utf-8"/>
    <title>Google Maps</title>
	<?php		
		require_once(dirname(__FILE__).'/xmlgooglemaps_googleMapsAPI.php');
		require_once(dirname(__FILE__).'/xmlgooglemaps_helper.php');
	
		$id = -1;
		if (isset($_GET["gpxid"])) {
			$id = intval($_GET["gpxid"]);			          
		} else {
			if (isset($_GET["kmlid"])) {
				$id = intval($_GET["kmlid"]);
			} else {
				if (isset($_GET["mygooglemapid"])) {
					$id = intval($_GET["mygooglemapid"]);
				} else {
					if (isset($_GET["myid"])) {
						$id = intval($_GET["myid"]); 				
					}
				}
			}
		}
		
		$varstring = getvarstring($id);
		$params = new xml_gm_params();	
		$params->setParams($varstring);	 
		$googlemaps = new googleMapAPI_PMPro($params->googleMapsAPIKey);
		$googlemaps->width = "100%";
		$googlemaps->height = strval($params->height-5)."px";
		$googlemaps->setMapType($params->viewStyle);
		$googlemaps->setPanZoomControl($params->panZoomControl);
		$googlemaps->setOverviewMap($params->overViewMapControl);
		$googlemaps->setScaleControl($params->scaleControl);
		$googlemaps->setMapTypeControl($params->mapTypeControl);
				
		print($googlemaps->getHeaderScript());
		print('<style type="text/css">p.entry {'.$params->gpxCSSStyle.'}</style>');
	?>
	</head>
	<body leftmargin="0" topmargin="0" marginwidth="0" marginheight="0" onunload="GUnload();">
	<?php
			
		if (isset($_GET["gpxid"])) {
			require_once(dirname(__FILE__).'/xmlgooglemaps_gpxParser.php');
			$file = getpathresolved($id);
			$gpxfile = new gpxParser();
			$gpxfile->parse($file);
			
			$gpxdata = $gpxfile->output;
					
			$maxwpt = $gpxdata["wpt_count"];
			$counter = 0;
			
			if (($params->gpxView == "all") || ($params->gpxView == "wpt")) {
				for ($counter=0; $counter<$maxwpt; $counter++) {
					$desc = "<b>".$gpxdata["wpt".$counter]["NAME"]."</b><br />".$gpxdata["wpt".$counter]["DESC"];
					$desc = str_replace('"',"'", $desc);
					$googlemaps->addMarker($gpxdata["wpt".$counter]["LAT"],$gpxdata["wpt".$counter]["LON"],"<p class='entry'>".$desc."</p>");	
				}
			}
			if (($params->gpxView == "all") || ($params->gpxView == "rte")) {
				$rtemax = $gpxdata["rte_count"];
				for ($rtecount=0;$rtecount<$rtemax; $rtecount++) {
					$rteptmax=$gpxdata["rte".$rtecount]["rtept_count"];
					$pl = $googlemaps->addPolyline($params->gpxLineColor,$params->gpxLineWidth,$params->gpxLineOpacity);
					
					for ($rteptcount=0;$rteptcount<$rteptmax; $rteptcount+=$params->gpxInterval) {
						$pt = $gpxdata["rte".$rtecount]["rtept".$rteptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}
					
					if ($rteptcount < $rteptmax - 1) {
						$rteptcount = $rteptmax - 1;
						$pt = $gpxdata["rte".$rtecount]["rtept".$rteptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);					
					}
				}
			}
			if (($params->gpxView == "all") || ($params->gpxView == "trk")) {
				$trkmax = $gpxdata["trk_count"];
				for ($trkcount=0;$trkcount<$trkmax; $trkcount++) {
					$trkptmax=$gpxdata["trk".$trkcount]["trkpt_count"];
					$pl = $googlemaps->addPolyline($params->gpxLineColor,$params->gpxLineWidth,$params->gpxLineOpacity);
					for ($trkptcount=0;$trkptcount<$trkptmax; $trkptcount+=$params->gpxInterval) {
						$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}	
					
					if ($trkptcount < $trkptmax - 1) {
						$trkptcount = $trkptmax - 1;
						$pt = $gpxdata["trk".$trkcount]["trkpt".$trkptcount];
						$googlemaps->addPolylinePoint($pl,$pt["LAT"],$pt["LON"]);
					}				
				}
			}			
			if ($params->manualZoom == 4) {
				$googlemaps->clearCenterCoords();
				$googlemaps->adjustCenterCoords($params->maxLon,$params->maxLat);
				$googlemaps->adjustCenterCoords($params->minLon,$params->minLat);
			}		
			$googlemaps->setZoom($params->zoom);
			$googlemaps->setDeltaZoom($params->deltazoom);	
			print($googlemaps->getContentElement());
		} else {
			if (isset($_GET["kmlid"])) {
				$file = getpathresolved($id);
				require_once(dirname(__FILE__).'/xmlgooglemaps_kmlParser.php');
				$kmlfile = new kmlParser();
				$kmlfile->parse($file);
				
				$kmldata = $kmlfile->output;
				
				for ($i=0; $i<count($kmldata["coordinates"]); $i++) 
				{
					$googlemaps->adjustCenterCoords($kmldata["coordinates"][$i]["lon"],$kmldata["coordinates"][$i]["lat"]);
				}
				
				if ($params->manualZoom == 4) {
					$googlemaps->clearCenterCoords();
					$googlemaps->adjustCenterCoords($params->maxLon,$params->maxLat);
					$googlemaps->adjustCenterCoords($params->minLon,$params->minLat);
				}			
								
				$file = getpath($id);
				$googlemaps->setZoom($params->zoom);
				$googlemaps->setDeltaZoom($params->deltazoom);
				print($googlemaps->getKMLContentElementOnly($file));				
			} else {				
				if (isset($_GET["mygooglemapid"])) {					
					if ($params->manualZoom == 4) {
						$googlemaps->clearCenterCoords();
						$googlemaps->adjustCenterCoords($params->maxLon,$params->maxLat);
						$googlemaps->adjustCenterCoords($params->minLon,$params->minLat);
					}																		
					$file = getpath($id);
					$googlemaps->setZoom($params->zoom);
					$googlemaps->setDeltaZoom($params->deltazoom);
					print($googlemaps->getKMLContentElementOnly($file));									
				} else {
					if (isset($_GET["myid"])) {
						if ($params->manualZoom == 4) {
							$googlemaps->clearCenterCoords();
							$googlemaps->adjustCenterCoords($params->maxLon,$params->maxLat);
							$googlemaps->adjustCenterCoords($params->minLon,$params->minLat);
						}		
						$googlemaps->setZoom($params->zoom);
						$googlemaps->setDeltaZoom($params->deltazoom);							
						print($googlemaps->getContentElement());
					}
				}
			}
		}
	?>
	</body>
</html>

<?php
	function getpath($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_path FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
	function getpathresolved($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_path_resolved FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
	function getvarstring($id) {
		global $wpdb;
		// Check IP From IP Logging Database
		$ret = $wpdb->get_var("SELECT xml_varstring FROM $wpdb->xmlgooglemapsdb WHERE xml_id = $id");
		return $ret;	
	}
	
?>